%global __provides_exclude_from ^%{_libdir}/pkgconfig/minizip\\.pc$

Summary:		A general purpose data compression/decompression library
Name:			zlib
Version:		1.2.13
Release:		8%{?dist}
License:		zlib and Boost
URL:			https://www.zlib.net/
Source0:		https://www.zlib.net/%{name}-%{version}.tar.xz

Patch0001:		0001-zlib-1.2.13-minizip-Check-length-of-comment-filename.patch
Patch0002: https://github.com/madler/zlib/commit/7a7202de3568522dfc75a455927ccbd7faf63411.patch
Patch0003: https://github.com/madler/zlib/commit/14a5f8f266c16c87ab6c086fc52b770b27701e01.patch
Patch3000:		zlib-1.2.5-minizip-fixuncrypt.patch
Patch3001:		zlib-1.2.11-covscan-issues-rhel9.patch

BuildRequires:	make automake autoconf libtool

%description
The zlib library is a general purpose data compression library. The code is 
thread safe, assuming that the standard library functions used are thread  
safe, such as memory allocation routines. It provides in-memory compression 
and decompression functions, including integrity checks of the uncompressed  
data. This version of the library supports only one compression method 
(deflation) but other algorithms may be added later with the same stream 
interface.

%package static
Summary: Static libraries for zlib development
Requires: %{name}-devel = %{version}-%{release}

%description static
This package provides static libraries for zlib development.

%package devel
Summary: Header files and libraries for zlib development
Requires: %{name} = %{version}-%{release}

%description devel
This package provides header files and libraries for zlib development.

%package -n minizip-compat
Summary: Library for manipulation with .zip archives
Requires: %{name} = %{version}-%{release}
# provides libminizip.so.1, which conflicts with minizip-ng
Conflicts: minizip-ng

%description -n minizip-compat
Minizip is a library for manipulation with files from .zip archives.

%package -n minizip-compat-devel
Summary: Header files and libraries for minizip development
Requires: minizip-compat = %{version}-%{release}
Requires: %{name}-devel = %{version}-%{release}
Conflicts: minizip-devel

%description -n minizip-compat-devel
This package provides header files and libraries for minizip development.

%prep
%autosetup -p1

%build
./configure --libdir=%{_libdir} --includedir=%{_includedir} --prefix=%{_prefix}
%make_build

cd contrib/minizip
autoreconf -fiv
%configure --enable-static=no
%make_build

%install
%make_install
%make_install -C contrib/minizip

rm -f %{buildroot}%{_libdir}/*.la
rm -f %{buildroot}%{_includedir}/minizip/crypt.h

%check
make test

%files
%license README
%doc ChangeLog FAQ doc/algorithm.txt test/example.c
%{_libdir}/libz.so.*
%{_mandir}/man3/zlib.3*

%files static
%{_libdir}/libz.a

%files devel
%{_includedir}/zlib.h
%{_includedir}/zconf.h
%{_libdir}/pkgconfig/zlib.pc
%{_libdir}/libz.so

%files -n minizip-compat
%license contrib/minizip/MiniZip64_info.txt
%doc contrib/minizip/MiniZip64_Changes.txt
%{_libdir}/libminizip.so.*

%files -n minizip-compat-devel
%dir %{_includedir}/minizip
%{_includedir}/minizip/*.h
%{_libdir}/pkgconfig/minizip.pc
%{_libdir}/libminizip.so

%changelog
* Mon Jan 13 2025 Tracker Robot <trackbot@opencloudos.tech> - 1.2.13-8
- [Type] security
- [DESC] Apply patches from rpm-tracker
- [CVE Fix] 14a5f8f266c16c87ab6c086fc52b770b27701e01.patch: Neutralize zip file traversal attacks in miniunz.

* Mon Jan 13 2025 Tracker Robot <trackbot@opencloudos.tech> - 1.2.13-7
- [Type] bugfix
- [DESC] Apply patches from rpm-tracker
- [Bug Fix] 7a7202de3568522dfc75a455927ccbd7faf63411.patch: Correct a variable type in deflate.c.

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.2.13-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.2.13-5
- Rebuilt for loongarch release

* Mon Jan 8 2024 wynnfeng <wynnfeng@tencent.com> -1.2.13-4
- Conflicts with minizip-ng

* Wed Oct 18 2023 Xiaojie Chen <jackxjchen@tencent.com> - 1.2.13-3
- Fix CVE-2023-45853

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.2.13-2
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Jun 08 2023 rockerzhu <rockerzhu@tencent.com> - 1.2.13-1
- Update to 1.2.13 to fix CVE-2022-37434.

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.2.12-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.2.12-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Jul 12 2022 Xiaojie Chen <jackxjchen@tencent.com> - 1.2.12-1
- Initial build
